#include <iostream>
#include <new>

#include "List.h"

using namespace std;

List::List() {
  cout << "> List() - construtor 1" << endl;
  head = NULL;
  maxsize = 10;
  size = 0;
}

List::List(int pMaxSize) {
  cout << "> List(int) - construtor 2" << endl;
  if (pMaxSize > 0) {
    head = NULL;
    maxsize = pMaxSize;
    //this->maxsize = pMaxSize;
    size = 0;
  } 
  else {
    List();
  }
}

List::List(const List &source) {
  cout << "> Copy constructor List(List&)\n";
  maxsize = source.maxsize;
  size = source.size;
  
  if (size > 0) {
     NODE *s = source.head;
     NODE *p = new NODE;
     p->value = s->value;
     head = p;
     for (s = s->next; s != NULL; s = s->next) {
         NODE *n = new NODE;
	 n->value = s->value;
	 n->next = NULL;
	 p->next = n;
	 p = n;
     }    
  } else
    head = NULL;
}


List& List::operator=(const List &right) {
  
  // verificar se &right == this
  // right e o proprio objeto
  // portanto comparamos o endereco de right
  // com o ponteiro this
  if (&right == this) {
     cout << "Left is equal Right\n";
     return *this; 
  }
  else {
        cout << "Free current object and copies the right into the left object\n";
        // desalocar a memoria ocupada pelo objeto atual
     	NODE *p, *ant;
	p = head;
	ant = head;
	while (p!=NULL) {
	  p = p->next;
	  delete ant;
	  ant = p;
	}
	head = NULL;

	// copiar informacoes
	maxsize = right.maxsize;
	size = right.size;
	if (size > 0) {
	    NODE *s = right.head;
	    
	    NODE *prev = new NODE;
            prev->value = s->value;
	    head = prev;

	    for (s = s->next; s != NULL; s = s->next) {
		NODE *n = new NODE;
		n->value = s->value;
		prev->next = n;
		prev = n;
	    }
	} else {
	  head = NULL;
	}    
  }
  return *this;
}    

List::~List() {
  cout << "< ~List() - destructor" << endl;
  NODE *p, *ant;
  p = head;
  ant = head;
  while (p!=NULL) {
    p = p->next;
    delete ant;
    ant = p;
  }
  
  head = NULL;
  size = 0;
  maxsize = 0;
}

int List::isEmpty() {
  return (size == 0); 
}

int List::isFull() {
  return (maxsize == size); 
}

void List::insertBegin(int pInsertValue) {
  if (isFull())
     return;
  
  NODE *p = new NODE;
  p->value = pInsertValue;
  p->next = head;
  head = p;
  size ++;
}

void List::printList() {
  NODE *p; 
  for (p = head; p != NULL; p = p->next) {
      cout << p->value << " ";    
  }  
  cout << endl;
}
